package {
	import flash.display.*
	import flash.events.*
	import flash.utils.*

public class Basic extends Sprite {
	//Менеджер прослушивателей событий
	private var myEventInfo:EventInfoPool = new EventInfoPool()

public function get lengthEL():int {
	//Количество зарегестрированных прослушивателей
	return myEventInfo.keyLength
}

public function get poolLength():int {
	//Количество неиспользуемых контейнеров прослушивателей
	return myEventInfo.poolLength
}

public function get poolInUse():int {
	//Общее количество зарегестрированных прослушивателей всеми классами
	return myEventInfo.poolInUse
}

public function get allPoolAndKeys():int {
	//Общее количество созданных контейнеров
	return myEventInfo.allPoolAndKeys
}

public function hasELinArray(values:Object = null,invert:Boolean = false):int {
	if (values == null) 
			return lengthEL
	//Пересчитываем все прослушиватели не удаляя
	return myEventInfo.removeSome(values,invert,false)
}

public function addEL(container:Object, type:String, paramlistener:Object, useCapture:Boolean = false, priority:int = 0, useWeakReference:Boolean = false):void {
	//Проверяем условия и добавляем прослушиватель, если проверка прошла успешно
	myEventInfo.addOne({ container:container, 
						type:type, 
						paramlistener:paramlistener,
						useCapture:useCapture,
						priority:priority,
						useWeakReference:useWeakReference})
}

public function addParam(container:Object, type:String, paramlistener:Object, useCapture:Boolean = false):void {
	//Проверяем условия и добавляем параметр, если данный параметр существует
	myEventInfo.addParam({ container:container, 
							type:type, 
							paramlistener:paramlistener,
							useCapture:useCapture})
}


public function getParam(container:Object, type:String, useCapture:Boolean = false):EventParameter {
	//Проверяем условия и добавляем параметр, если данный параметр существует
	return myEventInfo.getParam({ container:container, 
									type:type, 
									useCapture:useCapture})
}

public function removeEL(container:Object, type:String, listener:Function, useCapture:Boolean = false):void {
	//Если такой прослушиватель есть у обьекта, то убираем его
	myEventInfo.removeOne({ container:container, 
							type:type, 
							listener:listener,
							useCapture:useCapture})
}

public function removeSomeEL(values:Object = null,invert:Boolean = false):void {
	if (values == null) 
		return
	//Удаляем элементы
	myEventInfo.removeSome(values,invert,true)
}

public function removeAllEL():void {
	//Удаляем все прослушиватели из памяти и объекта
	myEventInfo.removeAll()
}

public function hasEL(type:String, container:Object = null):Boolean {
	(container == null)
		return false
	//Определяем класс полученного контейнера
	if (container is IEventDispatcher) {
		return container.hasEventListener(type)
	}
	return false
}
/**
 * Очистка контейнеров от данных
 * @param	container
 * @param	clearAll
 */
public function free(container:Object, clearAll:Boolean = false):void {
	//Переменные для циклов
	var cLength:int = 0
	var p:String = ""
	var contClass:Class = Object(container).constructor;
	//Обрабатываем контейнер
	if (contClass == Array) {
		//Размер массива
		cLength = container.length
		//Очищаем массив от объектов
		while (cLength--) {
			free(container[cLength], true)
			container.splice(cLength, 1);
		}
	}
	if (contClass == Object) {
		//Очищаем контейнер от объектов
		for (p in container) {
			free(container[p], true)
			delete container[p]
		}
	}
	if (contClass == Dictionary) {
		//Очищаем контейнер от объектов
		for (p in container) {
			free(container[p], true)
			delete container[p]
		}
	}
	//Удаляем прослушиватели
	if (container is Basic) {
		//Удаляем все прослушиватели из памяти и объекта
		container.removeAllEL()
	}
	//Очищаем контейнер от дочерних объектов
	if (container is DisplayObjectContainer) {
		//Колличество дочерних элементов
		while (container.numChildren) {
			//Ощищаем объекты входящие в данный объект
			free(container.getChildAt(0), true)
		}
	}
	//Удаляем сам контейнер
	if (clearAll) {
		if (container is DisplayObject){
			if (container.parent != null) {
				container.parent.removeChild(container)	
			}
		}
		//Очищаем Bitmap
		if (container is Bitmap) {
			container.bitmapData.dispose()
		}
		container = null
	}
}

}}