package  {
	import flash.display.*
	import flash.events.*
	import EventParameter
	
public class BasicTest extends Basic {
	
public function BasicTest() {
	if (stage) {
		init()
	} else {
		//Там где удаление будет гарантированно произведенно можно использовать 
		//более быстрый способ установки прослушивателей
		this.addEventListener(Event.ADDED_TO_STAGE, init)
	}
}

public function init():void {
	this.removeEventListener(Event.ADDED_TO_STAGE, init)
	//Получаем возможность использовать событие Resize
	stage.align = StageAlign.TOP_LEFT;
	stage.scaleMode = StageScaleMode.NO_SCALE
	//Создаем страницу
	createPage(stage.stageWidth, stage.stageHeight)
	
}

private function createPage(widht:int, heigth:int):void {
	//Рисуем страницу
	var page:Sprite = new Sprite
	page.graphics.beginFill(0x749395)
	page.graphics.drawRect(0, 0, widht, heigth)
	//Рисуем линию снизу
	page.graphics.lineStyle(50,0x425455)
	page.graphics.moveTo(26, heigth - 28)
	page.graphics.lineTo(widht - 26, heigth - 28)
	this.addChild(page)
	
	//Блок для кнопок
	var blok:Sprite = new Sprite
	this.addChild(blok)
	//Ставим чистый прослушиватель на блок
	var myParameter:EventParameter = new EventParameter()
	this.addEL(blok, MouseEvent.CLICK, myParameter)
	
	//Принимаем получившийся параметр
	myParameter = this.getParam(blok, MouseEvent.CLICK)
	//Рисуем кнопки в блок
	var i:int = 3
	while (i--) {
		var myButton:Button = new Button(this)
		myButton.x = (myButton.width + 10) * i
		myButton.y = 0
		blok.addChild(myButton)
		myParameter.add(myButton, clickParamListener, {button:i})
	}
	//Ставим блок по центру
	blok.x = widht * 0.5 - blok.width * 0.5
	blok.y = heigth * 0.5 - blok.height * 0.5 - 26
	
	//Ставим кнопку на полный экран
	var myEasyButton:Sprite = new Sprite
	myEasyButton.graphics.beginFill(0xA5D2D5)
	myEasyButton.graphics.drawRect(0, 0, 30, 30)
	myEasyButton.buttonMode = true
	//Кнопка всегда будет снизу справа
	myEasyButton.x = widht - myEasyButton.width - 26
	myEasyButton.y = heigth - myEasyButton.height - 13
	addChild(myEasyButton)
	//Устанавливаем прослушиватель изменение маштаба по щелчку
	this.addEL(myEasyButton, MouseEvent.CLICK, fullScreen)
	//Ставим прослушиватель изменения маштаба
	this.addEL(stage, Event.RESIZE, resize)
}

private function fullScreen(event:Event):void {
	//Растягиваем флэшку на полный экран, уменьшаем до нормальных размеров.
	if (stage.displayState == "normal") {
		stage.displayState = StageDisplayState.FULL_SCREEN;
	}else {
		stage.displayState=StageDisplayState.NORMAL
	}
}

private function resize(event:Event):void {
	//Полностью очищаем страницу
	this.free(this)
	//Восстанаваливаем страницу исходя из новых размеров
	createPage(stage.stageWidth, stage.stageHeight)
}

public function clickParamListener(event:MouseEvent, parameter:Object):void {
	//Получаем и обрабатываем параметры
	if("button" in parameter)
		var p:String = parameter["button"]
	/*====================== T R A C E  ===========================*/
	trace("button: " + p + " {BasicTest.clickParamListener}")
	trace()
	/*=================  E N D  T R A C E  ========================*/
}
	
}}

class Button extends Basic {

public function Button(main:Object) {
	//Рисуем кнопку
	this.graphics.beginFill(0xA5D2D5)
	this.graphics.drawRect(0, 0, 50, 50)
	this.buttonMode = true
}

}