package {
	import flash.display.Sprite
	import flash.events.*

public class EventInfoPool {
	//Количество одновременно создаваемых конейнеров
	private static var poolPack:int = 5
	//Глобальное хранилище контейнеров
	private static var poolTemp:Array/*EventInfo*/ = []
	//Глобальный счетчик используемых контейнеров
	private static var poolCounter:int = 0
	
	//Массив используемых контейнеров данным экземпляров класса
	private var poolKey:Vector.<EventInfo> = new Vector.<EventInfo>(0)

public function get keyLength():int {
	//Количество зарегестрированных прослушивателей
	return poolKey.length
}

public function get poolLength():int {
	//Количество неиспользуемых контейнеров прослушивателей
	return poolTemp.length
}

public function get poolInUse():int {
	//Общее количество зарегестрированных прослушивателей всеми классами
	return poolCounter
}

public function get allPoolAndKeys():int {
	//Общее количество созданных контейнеров
	return poolTemp.length + poolCounter
}

private function poolGet():EventInfo {
	//Передаем данные из глобального пула
	var instance:EventInfo
	//Если глобальное хранилище равно нулю, то создаем новые контейнеры
	if ( poolTemp.length ) {
		//Берем контейнер из хранилища
		instance = poolTemp.pop()
		//Вставляем в массив прослушивателей
		poolKey.push(instance)
		//Возвращаем данные в контейнере по умолчанию
		instance.clear()
		//Увеличиваем счетчик используемых контейнеров
		poolCounter++
		//Передаем контейнер
		return instance	
	}else {
		//Создаем новые контейнеры не по одному, а пачкой. И передаем их в глобальное хранилище
		var L:int = poolPack
		while (L--) {
			//Создаем новый контейнер
			var newPoolItem:EventInfo = new EventInfo()
			//Добавляем его в хранилище
			poolTemp.push(newPoolItem); 
		}
		return poolGet();
	}
}

public function addOne(eventArguments:Object):void {
	var myEventArgument:EventArgument = new EventArgument(eventArguments)
	//Если вместо функции передается параметр, то подменяем функцию
	var contClass:Class = Object(myEventArgument.paramlistener).constructor;
	if (contClass == EventParameter) {
		//Меняем фукцию для прослушивателя
		myEventArgument.listener   = eventHandler
	}else {
		myEventArgument.listener   = myEventArgument.paramlistener as Function
		myEventArgument.paramlistener = null
	}
	//Проверка всех прослушивателей
	var L:int = poolKey.length
	var instance:EventInfo
	while (L--)	{
		instance = poolKey[L]
		if (instance.container == myEventArgument.container && 
			instance.type == myEventArgument.type && 
			instance.listener == myEventArgument.listener && 
			instance.useCapture == myEventArgument.useCapture) {
			//Отмена добавления прослушивателя, если уже есть подобный
			return
		}
	}
	//Получаем контейнер для информации
	instance = poolGet()
	//Передаем данные в контейнер
	instance.container = myEventArgument.container;
	instance.type = myEventArgument.type;
	instance.listener = myEventArgument.listener;
	instance.useCapture = myEventArgument.useCapture;
	instance.parameter = myEventArgument.paramlistener as EventParameter
	//Добавляем прослушиватель
	myEventArgument.container.addEventListener (myEventArgument.type, 
													myEventArgument.listener, 
													myEventArgument.useCapture, 
													myEventArgument.priority, 
													myEventArgument.useWeakReference);
}

public function addParam(eventArguments:Object):void {
	var myEventArgument:EventArgument = new EventArgument(eventArguments)
	//Меняем фукцию для прослушивателя
	myEventArgument.listener   = eventHandler
	//Проверка всех прослушивателей
	var L:int = poolKey.length
	var instance:EventInfo
	while (L--)	{
		instance = poolKey[L]
		if (instance.container == myEventArgument.container && 
			instance.type == myEventArgument.type && 
			instance.listener == myEventArgument.listener && 
			instance.useCapture == myEventArgument.useCapture) {
			//Добавляем обработчики в параметр, если такой существует
			instance.parameter.concat(myEventArgument.paramlistener as EventParameter)
			return
		}
	}
}

public function getParam(eventArguments:Object):EventParameter {
	var myEventArgument:EventArgument = new EventArgument(eventArguments)
	//Меняем фукцию для прослушивателя
	myEventArgument.listener   = eventHandler
	//Проверка всех прослушивателей
	var L:int = poolKey.length
	var instance:EventInfo
	while (L--)	{
		instance = poolKey[L]
		if (instance.container == myEventArgument.container && 
			instance.type == myEventArgument.type && 
			instance.listener == myEventArgument.listener && 
			instance.useCapture == myEventArgument.useCapture) {
			//Передаем параметр, если такой существует
			return instance.parameter
		}
	}
	return null
}

private function eventHandler(event:Object = null):void {
	//Функция для передачи данных в обработчик события
	
	//Проверяем есть ли свойство eventPhase
	var myUseCapture:Boolean = false
	if ("eventPhase" in event) {
		var E:int = event.eventPhase
		if (event.eventPhase == EventPhase.CAPTURING_PHASE) {
			myUseCapture = true
		}
	}else {
		return
	}
	
	//Проверяем есть ли свойство type
	var myType:String = null
	if ("type" in event)
		myType = event.type
	if (myType == null)
		return
		
	//Проверяем есть ли свойство currentTargets
	var currentTarget:Object = null
	if ("currentTarget" in event)
		currentTarget = event.currentTarget
	if (currentTarget == null)
		return
	
	//Проверяем есть ли свойство target
	var target:Object = null
	if ("target" in event)
		target = event.target
	if (target == currentTarget)
		target = null
		
	//Поиск и обработка функций с параметрами
	var L:int = poolKey.length
	var instance:EventInfo
	while (L--)	{
		instance = poolKey[L]
		if (instance.container == currentTarget && 
				instance.type == myType && 
				instance.listener == eventHandler && 
				instance.useCapture == myUseCapture) {
			//Передаем параметр
			var myParameter:EventParameter = instance.parameter
			if (myParameter == null)
				return
			//Передаем информацию 
			var myInfo:ParameterInfo = myParameter.getInfo(currentTarget)
			if (myInfo != null)
				infoHandler(event, myInfo)
			if (target == null)
				return
			//Передаем информацию 
			myInfo = myParameter.getInfo(target)
			if (myInfo != null)
				infoHandler(event, myInfo)
			return
		}
	}
}

private function infoHandler(event:Object, myInfo:ParameterInfo):void {
	//Проверяем функцию
	var listener:Function = myInfo.listener
	if (listener == null)
		return
	var parameter:Object = myInfo.parameter
	//Выполняем функцию с параметрами
	listener(event, parameter)
}

public function removeOne(eventArguments:Object):void {
	var myEventArgument:EventArgument = new EventArgument(eventArguments)
	//Удаление одного элемента
	var L:int = poolKey.length
	var instance:EventInfo
	while (L--)	{
		instance = poolKey[L]
		if (instance.container == myEventArgument.container && 
				instance.type == myEventArgument.type && 
				instance.listener == myEventArgument.listener && 
				instance.useCapture == myEventArgument.useCapture) {

			//Убираем прослушиватель из памяти
			instance = poolKey.splice(L, 1)[0]
			//Возвращаем контейнер в пул, удаляем прослушиватель
			removeToPool(instance)
			return
		}
	}
}

public function removeAll():void {
	//Полная очистка
	var L:int = poolKey.length
	//Перебираем все прослушиватели
	while (L--)	{
		//Возвращаем контейнер в пул, удаляем прослушиватель
		removeToPool(poolKey[L])
	}
	//Быстро очищаем массив прослушивателей
	poolKey.length = 0
}

public function removeSome(values:Object,invert:Boolean,remove:Boolean):int {
	//Переменные для массивов
	var valueArray:Array/*EventInfo*/ = []
	var instance:EventInfo
	//Счетчик
	var numInfo:int = 0
	//Переменные для циклов
	var vItem:Object
	var hasKeys:Boolean = true
	//Проверка на массив
	var contClass:Class = Object(values).constructor;
	if (contClass == Array) {
		valueArray = values as Array
	}else {
		valueArray = [values]
	}
	//Размер массива параметров
	var valueLength:int = valueArray.length
	var vLength:int
	var L:int = poolKey.length
	//Перебираем весь массив myArrayListeners
	while (L--) {
		instance = poolKey[L]
		vLength = valueLength
		//Перебираем весь массив valueArray
		while (vLength--) {
			vItem = valueArray[vLength]
			hasKeys = true
			//Перебираем все параметры
			for (var p:String in vItem) {
				//Проверяем есть ли данное свойство
				if (!instance.hasOwnProperty(p)) {
					hasKeys = false
					break
				}
				//Проверяем на совпадение параметров
				if (instance[p] != vItem[p]) {
					hasKeys = false
					break
				}
			}
			//Если есть хоть одно полное совпадение, то заканчиваем проверку данного прослушивателя
			if (hasKeys) {
				break
			}
		}
		//Проверяем результат
		if (hasKeys) {
			//Если инвертирование, то ничего не делаем
			if (invert) 
				continue
			//Пересчитываем при обычном запросе
			numInfo++
			//Удаляем прослушиватель, если задано удаление
			if (!remove)
				continue
			//Убираем прослушиватель из памяти
			instance = poolKey.splice(L, 1)[0]
			//Возвращаем контейнер в пул, удаляем прослушиватель
			removeToPool(instance)
		}else {
			//Если обычный запрос, то ничего не делаем.
			if (!invert)
				continue 
			//Пересчитываем при инвертировании
			numInfo++
			//Удаляем прослушиватель, если задано удаление
			if (!remove)
				continue
			//Убираем прослушиватель из памяти
			instance = poolKey.splice(L, 1)[0]
			//Возвращаем контейнер в пул, удаляем прослушиватель
			removeToPool(instance)
		}
	}
	return numInfo
}

private function removeToPool(instance:EventInfo):void {
	//Возвращаем контейнер в пул
	poolTemp.push(instance)
	//Уменьшаем счетчик используемых контейнеров
	poolCounter--
	var container:Object = instance.container
	//Если контейнера не существует, то заканчиваем выполнение функции. Иначе удаляем прослушиватель
	if (!container)
		return
	//Удаляем прослушиватель
	container.removeEventListener (instance.type, instance.listener, instance.useCapture);
}

}}